Loading...
Searching...
No Matches
Sip_security_verify

## Macros

#define | sip_security_verify(sip)
| Access a SIP Security-Verify header structure sip_security_verify_t from sip_t.
#define | SIP_SECURITY_VERIFY_INIT()
| Initializer for structure sip_security_verify_t.
#define | SIPTAG_SECURITY_VERIFY(x)
| Tag list item for pointer to a Security-Verify header structure sip_security_verify_t.
#define | SIPTAG_SECURITY_VERIFY_REF(x)
| Tag list item for reference to a Security-Verify header pointer.
#define | SIPTAG_SECURITY_VERIFY_STR(s)
| Tag list item for string with Security-Verify header value.
#define | SIPTAG_SECURITY_VERIFY_STR_REF(x)
| Tag list item for reference to a Security-Verify header string.

## Typedefs

typedef struct sip_security_agree_s | sip_security_verify_t
| @

## Functions

issize_t | sip_security_verify_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Security-Verify header.
issize_t | sip_security_verify_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Security-Verify header.
sip_security_verify_t * | sip_security_verify_init (sip_security_verify_t x[1])
| Initialize a structure sip_security_verify_t.
int | sip_is_security_verify (sip_header_t const *header)
| Test if header object is instance of sip_security_verify_t.
sip_security_verify_t * | sip_security_verify_dup (su_home_t *home, sip_security_verify_t const *hdr))
| Duplicate a list of Security-Verify header header structures sip_security_verify_t.
sip_security_verify_t * | sip_security_verify_copy (su_home_t *home, sip_security_verify_t const *hdr))
| Copy a list of Security-Verify header header structures sip_security_verify_t.
sip_security_verify_t * | sip_security_verify_make (su_home_t *home, char const *s))
| Make a Security-Verify header structure sip_security_verify_t.
sip_security_verify_t * | sip_security_verify_format (su_home_t *home, char const *fmt,...)))
| Make a Security-Verify header from formatting result.

## Variables

msg_hclass_t | sip_security_verify_class []
| Header class for Security-Verify header.
tag_typedef_t | siptag_security_verify
| Tag for Security-Verify header object.
tag_typedef_t | siptag_security_verify_str
| Tag for string with Security-Verify header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SECURITY_VERIFY_INIT

#define SIP_SECURITY_VERIFY_INIT | ( |  | ) |

Initializer for structure sip_security_verify_t.

A static sip_security_verify_t structure for Security-Verify header must be initialized with the SIP_SECURITY_VERIFY_INIT() macro. For instance,

sip_security_verify_t sip_security_verify = SIP_SECURITY_VERIFY_INIT;
sip_security_verify
#define sip_security_verify(sip)
Access a SIP Security-Verify header structure sip_security_verify_t from sip_t.
Definition sip_protos.h:13697
sip_security_verify_t
struct sip_security_agree_s sip_security_verify_t
@
Definition sip.h:216
SIP_SECURITY_VERIFY_INIT
#define SIP_SECURITY_VERIFY_INIT()
Initializer for structure sip_security_verify_t.
Definition sip_protos.h:13714

## SIPTAG_SECURITY_VERIFY

#define SIPTAG_SECURITY_VERIFY | ( |  | x | ) |

Tag list item for pointer to a Security-Verify header structure sip_security_verify_t.

The SIPTAG_SECURITY_VERIFY() macro is used to include a tag item with a pointer to a sip_security_verify_t structure in a tag list.

Parameters

  x | pointer to a sip_security_verify_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SECURITY_VERIFY_REF().

## SIPTAG_SECURITY_VERIFY_STR

#define SIPTAG_SECURITY_VERIFY_STR | ( |  | s | ) |

Tag list item for string with Security-Verify header value.

The SIPTAG_SECURITY_VERIFY_STR() macro is used to include a tag item with a string containing value of a sip_security_verify_t header in a tag list.

Parameters

  s | pointer to a string containing Security-Verify header value, or NULL.

The string in SIPTAG_SECURITY_VERIFY_STR() can be converted to a sip_security_verify_t header structure by giving the string s has second argument to function sip_security_verify_make().

The corresponding tag taking reference parameter is SIPTAG_SECURITY_VERIFY_STR_REF().

## Typedef Documentation

## sip_security_verify_t

typedef struct sip_security_agree_s sip_security_verify_t

@

The Security-Verify header is defined by RFC 3329, "Security Mechanism Agreement for the Session Initiation Protocol (SIP)".

See also
  Security-Client, Security-Server, sip_security_verify_compare(), sip_security_client_select(), RFC 3329.

The parsed Security-Verify header is stored in sip_security_verify_t structure.

The structure sip_security_verify_t contains representation of SIP Security-Verify header.

The sip_security_verify_t is defined as follows:

typedef struct sip_security_agree_s
{
sip_common_t sa_common[1]; // Common fragment info
sip_security_verify_t *sa_next; // Link to next mechanism
char const *sa_mec; // Security mechanism
msg_param_t const *sa_params; // List of mechanism parameters
char const *sa_q; // Value of q (preference) parameter
char const *sa_d_alg; // Value of d-alg parameter
char const *sa_d_qop; // Value of d-qop parameter
char const *sa_d_ver; // Value of d-ver parameter
} sip_security_verify_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_security_agree_s
Structure for Security-Client, Security-Server, and Security-Verify headers.
Definition sip.h:774
sip_security_agree_s::sa_common
sip_common_t sa_common[1]
Common fragment info.
Definition sip.h:775
sip_security_agree_s::sa_params
msg_param_t const * sa_params
List of mechanism parameters.
Definition sip.h:779
sip_security_agree_s::sa_d_alg
char const * sa_d_alg
Value of d-alg parameter.
Definition sip.h:781
sip_security_agree_s::sa_d_ver
char const * sa_d_ver
Value of d-ver parameter.
Definition sip.h:783
sip_security_agree_s::sa_mec
char const * sa_mec
Security mechanism.
Definition sip.h:778
sip_security_agree_s::sa_next
struct sip_security_agree_s * sa_next
Link to next mechanism.
Definition sip.h:776
sip_security_agree_s::sa_q
char const * sa_q
Value of q (preference) parameter.
Definition sip.h:780
sip_security_agree_s::sa_d_qop
char const * sa_d_qop
Value of d-qop parameter.
Definition sip.h:782

## Function Documentation

## sip_is_security_verify()

int sip_is_security_verify | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_security_verify_t.

Check if the header class is an instance of Security-Verify header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header security_verify
  0 | (false) otherwise

## sip_security_verify_copy()

sip_security_verify_t * sip_security_verify_copy | ( | su_home_t * | home,
|  | sip_security_verify_t const * | hdr )

inline

Copy a list of Security-Verify header header structures sip_security_verify_t.

The function sip_security_verify_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  security_verify = sip_security_verify_copy(home, sip->sip_security_verify);
  sip_security_verify_copy
  sip_security_verify_t * sip_security_verify_copy(su_home_t *home, sip_security_verify_t const *hdr))
  Copy a list of Security-Verify header header structures sip_security_verify_t.
  Definition sip_protos.h:13844

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_security_verify_dup()

sip_security_verify_t * sip_security_verify_dup | ( | su_home_t * | home,
|  | sip_security_verify_t const * | hdr )

inline

Duplicate a list of Security-Verify header header structures sip_security_verify_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  security_verify = sip_security_verify_dup(home, sip->sip_security_verify);
  sip_security_verify_dup
  sip_security_verify_t * sip_security_verify_dup(su_home_t *home, sip_security_verify_t const *hdr))
  Duplicate a list of Security-Verify header header structures sip_security_verify_t.
  Definition sip_protos.h:13801

Returns
  A pointer to the newly duplicated sip_security_verify_t header structure, or NULL upon an error.

## sip_security_verify_format()

sip_security_verify_t * sip_security_verify_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Security-Verify header from formatting result.

Make a new sip_security_verify_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_security_verify_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_security_verify_init()

sip_security_verify_t * sip_security_verify_init | ( | sip_security_verify_t | x[1] | ) |

inline

Initialize a structure sip_security_verify_t.

An sip_security_verify_t structure for Security-Verify header can be initialized with the sip_security_verify_init() function/macro. For instance,

sip_security_verify_t sip_security_verify;
sip_security_verify_init(&sip_security_verify);
sip_security_verify_init
sip_security_verify_t * sip_security_verify_init(sip_security_verify_t x[1])
Initialize a structure sip_security_verify_t.
Definition sip_protos.h:13732

## sip_security_verify_make()

sip_security_verify_t * sip_security_verify_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Security-Verify header structure sip_security_verify_t.

The function sip_security_verify_make() makes a new sip_security_verify_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_security_verify_t header structure, or NULL upon an error.

## Variable Documentation

## sip_security_verify_class

msg_hclass_t sip_security_verify_class[]

extern

Header class for Security-Verify header.

The header class sip_security_verify_class defines how a SIP Security-Verify header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_security_verify_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.